;************************
;*    Something to Do.  *
;*       Engine  V2     *
;*       BY XAVSNAP     *
;************************


ORG +16514

@DECODE=07BD
@DEST=+16402
@DFILE=+16396
@SEED=+16434
@FAST=2D6
@SLOW=2BF
@CLS=A2A
@KEYLOW=+16421
@KEYHI=+16422
@NXTL= 4029
@EXTERR=005B
@KEYB=02BB
@SCROLL=0C0E
@AKEY=+3893

;POINT TO B (BC)
@TEMP8=+16416

@TP16A=+16507
@TP16B=+16508

@DFZCC=400E
@PICOFF=46B0

;NUMBER OF OBJECTS
@NBOBJ=+25

;DECODE SHORT STR
@NBOBJ2=+20
@NBCOM2=+36

@NBOBJ3=+21
@NBCOM3=+37

"std" 76 76
;***
; OLD DF
@OLDDF   ; 16519
00 00 

@NEWDF   ; 16521
00 00

@STATBUFF  ; 16523
00 00

@INIT
LD HL,(DFILE)
LD (OLDDF),HL

LD HL,(DEST)
LD BC,21
ADD HL,BC
LD A, 76
LD (HL),A
LD (DFILE),HL
LD (NEWDF),HL
JP RETBAS

@END
LD HL,(OLDDF)
LD (DFILE),HL
RET

@START
LD HL,(OLDDF)
LD DE,(NEWDF)
SBC HL,DE
RET P
LD (DFILE),DE
RET

@CLS
LD HL,(NEWDF)
LD A, 0
LD C,+24

@RET0
LD B,+34
@RET1
INC HL
LD (HL),A
DJNZ RET1
DEC C
JR NZ RET0
RET

@SCROLLL
CALL SCROLL1
JP RETBAS

;SCOLL UP
@SCROLL1
LD HL,(NEWDF)
INC HL
LD BC,+34
ADD HL,BC
LD D,H
LD E,L
SBC HL,BC
EX DE,HL
LD BC,+782
LDIR
EX DE,HL
LD B,+34
LD A,0
@RETSCR1
LD (HL),A
INC HL
DJNZ RETSCR1
RET

@SCROLLA
LD B,+24
@RETSCR2
PUSH BC
CALL SCROLL1
POP BC
DJNZ RETSCR2
JP RETBAS

@XORS
LD HL,(NEWDF)
LD C,+24

@RET2
LD B,+34
@RET3
INC HL
LD A, (HL)
XOR +128
LD (HL),A
DJNZ RET3
DEC C
JR NZ RET2
RET

@XORL
LD HL,(DEST)
LD B,+34
@RET4
LD A, (HL)
XOR +128
LD (HL),A
INC HL
DJNZ RET4
JP RETBAS

;GL offset
;
;SCROLLING EXAMPLE 
;<-

LD HL,(NEWDF)
LD D,H
LD E,L
INC HL
EXX
LD B,+24
@RET5  
EXX
INC DE
INC HL
LD BC,+33
LD A,(DE)
;HL -> DE
;BC=BC+1
LDIR
LD (DE),A
EXX
DJNZ RET5
EXX
RET

;->

LD HL,(NEWDF)
LD D,H
LD E,L
INC DE
EXX

LD B,+24
@RET6  
EXX
LD DE,+33
ADD HL,DE
LD D,H
LD E,L
INC DE
LD BC,+33
LD A,(DE)
;HL -> DE
;BC=BC-1
LDDR
LD (DE),A
LD DE,+34
ADD HL,DE
EXX
DJNZ RET6
EXX
RET

@RLL
LD HL,(DEST)
LD D,H
LD E,L
DEC DE
EXX
LD B,1
CALL RET5
JR RETBAS

@RRL
LD HL,(DEST)
DEC HL
LD D,H
LD E,L
INC DE
EXX
LD B,1
CALL RET6

@RETBAS
JP EXTERR

;************

JP DPIC
JP KBINP
JP CMPINP
JP RESDIR
JP MAINDISP
JP OBJARG
JP INV
JP CDFILE

;************
@DPIC
LD BC,(TEMP8)
LD HL,PICOFF
LD DE,+192
SBC HL,DE
@NBADD
ADD HL,DE
DJNZ NBADD
LD (407B),HL
JR DISPLAY

@DISPLAY
LD HL,(DEST)
LD DE,(407B)
LD C,+16
CALL NXTLD
@ENDDISP
JR RETBAS

@NXTLD
LD B,+12

@DCONT
LD A,(DE)
RR A
RR A
RR A
RR A
CALL DISPC
LD A,(DE)
CALL DISPC
INC DE
DJNZ DCONT
DEC C
RET Z 
LD (407B),DE
LD DE,+10
ADD HL,DE
LD DE,(407B)
JR NXTLD

@DISPC
AND +15
SUB +8
JP M DISP1
ADD A,+120
@DISP1
ADD A,+8
LD (HL),A
INC HL
RET

;************


@KBINP
LD HL,(DEST)
LD E,(HL)    
LD A,(HL)
LD (DFZCC),HL

@KBRET0
PUSH AF      
PUSH HL      
CALL KEYB; [KEYBOARD]
LD B,H       
LD C,L       
POP HL       
POP AF
LD HL,(DFZCC)       
XOR 80    
LD (HL),A    
LD D,C       
INC D
JR Z KBRET0
    
LD (HL),E    
CALL DECODE
LD A,(HL)
CP 76
JR Z EXITKB
CP 77
JR Z DCAR

LD HL,(DFZCC)
AND +127
LD (HL),A
INC HL
LD (DFZCC),HL

@RETP   
LD D,A       
XOR 80    
LD BC,1B58  
@KBRET1    
DEC BC       
LD A,B       
OR C       
JR NZ KBRET1 
JR KBRET0

@DCAR
LD HL,(DFZCC)
LD BC,(DEST)
SBC HL,BC
JR Z RETP
LD HL,(DFZCC)
LD A,0
LD (HL),A
DEC HL
LD (DFZCC),HL
JR RETP
    
@EXITKB
LD HL,(DFZCC)
LD A,0
LD (HL),A

;RESET COMMANDES
LD HL,BUFFCOM
LD BC,1200
@RCOMM
LD (HL),A
DJNZ RCOMM

LD HL,(DEST)
LD DE,BUFFCOM
LD BC,4
LDIR 

LD HL,(DEST)
CALL FSPACE
LD DE,BUFFOBJ1
LD BC,4
LDIR
 
DEC HL
DEC HL
DEC HL

;ON/WITH
CALL FSPACE
LD DE,BUFFOBJ2
LD BC,2
LDIR 

DEC HL
DEC HL

;ON/WITH
CALL FSPACE
LD DE,BUFFOBJ3
LD BC,4
LDIR 

JP EXTERR

@FSPACE
@LOOP1
LD A,(HL)
CP 00
INC HL
JP NZ LOOP1
RET

@BUFFCOM
00 00 00 00
@BUFFOBJ1
00 00 00 00
@BUFFOBJ2
00 00
@BUFFOBJ3
00 00 00 00
@RESULTC
00
@RESULTO1
00
@RESULTO2
00
@RESULTO3
00

;************
; COMPARE INPUT
@CMPINP
;ARG 1
LD DE,BUFFCOM
LD HL,ISCOM
LD BC,4
SBC  HL,BC
LD BC,NBCOM2
CALL DECCHR
LD A,B
INC A
LD (RESULTC),A

;ARG 2
LD DE,BUFFOBJ1
CALL SCANOBJ
LD (RESULTO1),A

;ARG 3
LD A,(BUFFOBJ2)
; TO
CP 0 
JR Z NXT1
SUB 25 
@NXT1
LD (RESULTO2),A

@NXTSO

;ARG 4
LD DE,BUFFOBJ3
CALL SCANOBJ
LD (RESULTO3),A

;RESET OBJ TO 0
;IF NOT FOUND
LD A,(RESULTC)
CP NBCOM3
JR NZ COC1
LD A,0
@COC1
LD (RESULTC),A
LD HL,(RESULTC)
LD B,L
LD C,H
;SET STAT
RET

@SCANOBJ
LD HL,ISOBJ
LD BC,4
SBC  HL,BC
LD BC,NBOBJ2
CALL DECCHR
LD A,B
INC A
CP NBOBJ3
RET NZ
LD A,0
RET

@DECCHR
@LOOP21
LD A,C
CP B
RET Z
INC HL
@LOOP22
INC HL
@LOOP23
INC HL
@LOOP24
INC HL

; CHAR 1
LD A,(DE)
CP (HL)
JR Z LOOPC1
INC B
JR LOOP21

@LOOPC1
; CHAR 2
INC HL
INC DE
LD A,(DE)
CP (HL)
JR Z LOOPC2
INC B
DEC DE
JR LOOP22

@LOOPC2
; CHAR 3
INC HL
INC DE
LD A,(DE)
CP (HL)
JR Z LOOPC3
CP 0
RET Z
INC B
DEC DE
DEC DE
JR LOOP23

@LOOPC3
; CHAR 4
INC HL
INC DE
LD A,(DE)
CP (HL)
RET Z
CP 0
RET Z
INC B
DEC DE
DEC DE
DEC DE
JR LOOP24

;************

@RESDIR
LD HL,(NEWDF)
LD DE,(DEST)
LD BC,A4
ADD HL,BC
LD A,(DE)
CP 0
JR Z N1
LD (HL),"N"
JR N10
@N1
LD (HL),"n"
@N10
INC DE
INC DE
INC DE
INC DE
INC HL
INC HL
INC HL
LD A,(DE)
CP 0
JR Z N2
LD (HL),"U"
JR N20
@N2
LD (HL),"u"
@N20
DEC DE
LD BC,+30
ADD HL,BC
LD A,(DE)
CP 0
JR Z N3
LD (HL),"W"
JR N30
@N3
LD (HL),"w"
@N30
DEC DE
DEC DE
INC HL
INC HL
LD A,(DE)
CP 0
JR Z N4
LD (HL),"E"
JR N40
@N4
LD (HL),"e"
@N40
INC DE
LD BC,+33
ADD HL,BC
LD A,(DE)
CP 0
JR Z N5
LD (HL),"S"
JR N50
@N5
LD (HL),"s"
@N50
INC DE
INC DE
INC DE
INC HL
INC HL
INC HL
LD A,(DE)
CP 0
JR Z N6
LD (HL),"D"
JR N60
@N6
LD (HL),"d"
@N60
JP EXTERR

;************

@MAINDISP
;GET OBJ NAME
LD HL,(NEWDF)
LD BC,14C
ADD HL,BC
LD BC,F6
ADD HL,BC
LD A,85
LD (HL),A
SBC HL,BC

LD D,H
LD E,L
LD BC,800
@M1
PUSH BC
CALL DELOBJ
POP BC
DJNZ M1

EX DE,HL

LD DE,(DEST)
DEC DE

LD BC,(TEMP8)
LD C,0
LD A,0
LD (OBJDIS),A
LD (BUFFINV),A
LD (OBJCNT),HL

@RID1
INC DE
LD A,C
CP NBOBJ
JR Z ENDSCAN
LD A,(DE)
CP B
PUSH BC
JP Z DISPOBJ
JR DDISP

@DDISP0
DEC DE
DEC DE

@DDISP
INC DE
PUSH HL
LD H,D
LD L,E
LD A,(HL)
LD B,0
LD C,A
ADD HL,BC
EX DE,HL
INC DE
POP HL
POP BC
INC C
JR RID1

@DISPOBJ
INC DE
LD A,(DE)
LD C,A
INC DE

LD A,(BUFFINV)

;INVENTORY
CP 1
JR Z DISINV

LD A,(DE)
CP 0
JR Z DDISP0
CP 3
JR Z DDISP0
JR DISPALL

@DISINV
LD A,(DE)
CP 3
JR NZ DDISP0


@DISPALL
INC DE

; TEST IF FULL

LD A,(OBJDIS)
INC A
LD (OBJDIS),A
SUB 9
JP P END8

LD B,0
SCF
LD A,0
LD A,C
EX DE,HL
LDIR
EX DE,HL
LD C,A
SBC HL,BC



LD BC,23
ADD HL,BC

POP BC
INC C
DEC DE
JR RID1

@DELOBJ
LD BC,800

@M12
LD (HL),0
INC HL
DJNZ M12
LD BC,1A
ADD HL,BC
RET

@END8
LD BC,+26
SBC HL,BC
LD A,BB
LD (HL),A

@ENDSCAN

LD BC,(OBJCNT)
LD (OBJCNT),HL
SBC HL,BC
JR NZ ENDSCAN2
LD HL,CHR2
LD DE,(OBJCNT)
LD BC,7
LDIR

@ENDSCAN2
LD A,(BUFFINV)
CP 1
JR NZ NKEY
CALL INITKB
@SKB
LD A,(KEYLOW)
CP FF
JR Z SKB
CALL INITKB
@NKEY

JP EXTERR

@INITKB
LD A,FF
LD (KEYLOW),A
LD (KEYHI),A
RET

;************

@OBJARG
LD HL,TP16B
LD A,(HL)
CP 0
JR Z NOSCA
LD DE,(DEST)

LD B,A
LD C,0

@RID12

PUSH BC
INC DE
LD HL,DE
LD H,D
LD L,E
INC HL
PUSH HL
LD H,D
LD L,E
LD A,(HL)
LD B,0
LD C,A
ADD HL,BC
EX DE,HL
POP HL
INC DE
INC DE
POP BC

DJNZ RID12

EX DE,HL
;DE=OBJ OFF

LD HL,STATBUFF

@JF4
LD A,(TP16A)
CP 1
JR Z JF3
CP 2
JR Z JF7
CP 3
JR Z JF13
CP 4
JR Z JF14
CP 5
JR Z JF15
CP 6
JR Z JF16
CP 7
JR Z JF17
EX DE,HL
LD A,(HL)
EX DE,HL
@NOSCA
LD (HL),A ; NO OBJ
JR REXIT

@JF7
; PUT THE OBJECT.
LD A,(DE)
CP 3
JR NZ NOSCA
LD A,1
LD (DE),A
LD A,(+16417)
DEC DE
DEC DE
LD (DE),A 
LD (HL),5 ; DROP IT
JR REDRAW

@JF3
; GET THE OBJECT.
LD A,(DE)
CP 4
JR Z JF11  ;CAN'T
CP 3
JR Z JF9  ;INVENT
CP 2
JR Z JF1  ;TOO HEAVY
CP 0
JR Z JF10 ;INACTIVE
DEC DE
DEC DE
LD A,(+16417)
LD B,A
LD A,(DE)
CP 0
JR Z NOSCA
CP B
JR NZ NOSCA
LD A,0
LD (DE),A
INC DE
INC DE
LD A,3
LD (DE),A
LD (HL),4 ; GOT IT
JR REDRAW

@JF6
LD (DE),A
LD (HL),A

@REDRAW
LD A,0
LD (BUFFINV),A
CALL MAINDISP
JR REXIT

@JF1
LD (HL),3 ; TOO HEAVY
JR REXIT

@JF10
LD (HL),1 ; INACTIVE
JR REXIT

@JF11
LD (HL),8 ; CAN'T
JR REXIT

@JF9
LD (HL),2 ; INVENTORY
@REXIT
JP EXTERR

@JF13
LD A,1
JR JF6
@JF14
LD A,0
JR JF6
@JF15
LD A,2
JR JF6
@JF16
LD A,3
JR JF6
@JF17
LD A,4
JR JF6
;************
; INVENTORY

@INV


LD HL,(NEWDF)
;BC = 10x34+1
LD BC,89
ADD HL,BC
PUSH HL

LD HL,PICOFF

; PIC NO 11
; BC=10x192
LD BC,0780
ADD HL,BC
EX DE,HL
POP HL
LD C,+16
CALL NXTLD

LD HL,(NEWDF)
;BC = 19x34+5
LD BC,+653
ADD HL,BC
LD DE,CHR3
LD BC,+13
EX DE,HL
LDIR

LD HL,(NEWDF)
;BC = 9x34+10
LD BC,+315
ADD HL,BC
LD DE,CHR1
LD BC,9
EX DE,HL
LDIR
EX DE,HL
;BC = 2x34-6
LD BC,+94
ADD HL,BC
LD (OBJCNT),HL

LD A,1
LD (BUFFINV),A
LD A,0
LD (OBJDIS),A
LD DE,(DEST)
DEC DE
LD BC,0
JP RID1

;************
;COLLAPPSE DFILE
@CDFILE
LD A,0
LD (+16418),A
LD BC,1800
@RETSCRL
PUSH BC
CALL SCROLL
POP BC
DJNZ RETSCRL
LD A,2
LD (+16418),A
RET

@BUFFINV
00
@OBJPTR
00 00

@OBJCNT
00 00

@OBJDIS
00

@CHR1
"you"
80
80
"have"

@CHR2
"NOTHING"

@CHR3 ; 13CH
92
"press"
80
"a"
80
"key"
93

@ISCOM
"QUIT"
"EXIT"
"LOOK"
"DROP"
"PUT "
"USE "
"TAKE"
"GET "
"DRIN"
"OPEN"
"EXAM"
"EAT "
"PULL"
"WAIT"
"ENTE"
"SAVE"
"FUCK"
"JUMP"
"NORT"
"EST "
"SOUT"
"WEST"
"UP  "
"DOWN"
"N   "
"E   "
"S   "
"W   "
"U   "
"D   "
"I   "
"INVE"
"LIST"
"Q   "
"TYPE"

@ISOBJ
"CAN "
"KEY "
"COFF"
"COIN"
"MACH"
"DESK"
"NOTE"
"JACK"
"GRID"
"SCRE"

"COMM"
"MAGA"
"DOOR"
"POD "
"BADG"
"CARD"
"BUTT"
"SIGN"
"PAPE"
"WATE"
